@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:runFullFlash
color f9
@title %title% %version% - Flash full firmware [%serial_number%]

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo. ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    echo.
    echo. ======== Flashing BL ^( Bootloader Part ^) ========

    call "%~dp0doFlashBLPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] BL ^( Bootloader Part ^) flash failed.
        goto :flashFailedLabel
    )

    echo.
    REM reboot-bootloader to apply new bootloader.
    echo. ------ Rebooting fastboot ------
    %fastboot%  -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Rebooting Fastboot failed^^!
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo. ======== Flashing BP ^( Baseband Part ^) ========

    call "%~dp0doFlashBPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] BP ^( Baseband Part ^) flash failed.
        goto :flashFailedLabel
    )

    echo.
    echo. ======== Flashing AP ^( Android OS Part ^) ========

    call "%~dp0doFlashAPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] AP ^( Android OS Part ^) flash failed.
        goto :flashFailedLabel
    )

    echo.
    echo. ======== Factory reset ========

    call "%~dp0doFactoryReset.cmd"
    if %errorlevel% NEQ 0 (
        echo. Device [%serial_number%] factory reset failed.
        goto :flashFailedLabel
    )

    call "%~dp0doEraseModemst.cmd"

    echo.
    echo. ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    echo.
    echo. Device [%serial_number%] all operations are complete.

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo. Press any key to exit.
    pause > nul
::
::
:exit
exit
