@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:runUnlockBL
color f9
@title %title% %version% - Unlock Bootloader [%serial_number%]

    if "%1" == "" (
        color fc
        echo.
        echo. Fatal Error: Option is null.
        goto :tips
    ) else (
        set unlock_option=%1
    )

    REM call "%~dp0getPartitionTable.cmd"

    if "%unlock_option%" == "1" call :doUnlockBL1
    if "%unlock_option%" == "2" call :doUnlockBL2
    if "%unlock_option%" == "3" call :runGetUnlockData

    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] operation failed.
        echo.
        goto :tips
    ) else (
        echo.
        echo. Device [%serial_number%] operation is complete.
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:doUnlockBL1
@title %title% %version% - Unlock Bootloader [%serial_number%]
    echo.
    echo. Executing: fastboot -s %serial_number% oem unlock
    %fastboot% -s %serial_number% oem unlock
    if %errorlevel% NEQ 0 (
        color fc
        echo. ---------------------------
        echo. Error: Operation failed^^!
        echo. ---------------------------
        exit /b 1
    ) else (
        color f2
        echo.
        echo. The operation is complete.
    )

exit /b 0
::
::
:doUnlockBL2
@title %title% %version% - Unlock Motorola Bootloader [%serial_number%]
    echo.
    echo. [-] NOTE: Please enter the unlock code for [%serial_number%], then press Enter.
    echo. [-] For example: DVNJ6NFFT2MLEZABQ4FQ
    echo.
    set unlockcode=
    set /p unlockcode= Please enter the unlock code: ^>^>
        if "%unlockcode%"=="" (
            echo. The input is incorrect, please re-enter.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :doUnlockBL2
        )

    echo.
    echo. Executing: fastboot -s %serial_number% oem unlock %unlockcode%
    %fastboot% -s %serial_number% oem unlock %unlockcode%
    REM Confirm unlock again
    %fastboot% -s %serial_number% oem unlock %unlockcode%
    if %errorlevel% NEQ 0 (
        color fc
        echo. ---------------------------
        echo. Error: Operation failed^^!
        echo. ---------------------------
        exit /b 1
    ) else (
        color f2
        echo.
        echo. The operation was successful.
    )

exit /b 0
::
::
:runGetUnlockData
@title %title% %version% - Get Bootloader Unlock Data [%serial_number%]

    echo.
    echo. Fetch Bootloader unlock data for [%serial_number%]:
    echo.
    call "%~dp0doGetUnlockData.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Fetching Bootloader unlock data failed^^!
        goto :tips
    )

    echo %ULKData%

    if "%device_count%" == "1" (
        echo.
        echo. Your unlock data has been copied to the clipboard.
        echo %ULKData% | clip
    )

    if "%device_count%" NEQ "1" (
        echo.
        echo. Writing file: UnlockData_%serial_number%.txt
        echo %ULKData% > UnlockData_%serial_number%.txt
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo. Press any key to exit.
    pause > nul
::
::
:exit
exit
